tell application "Aether"
tell document 1
set qsocall to missing value
set qsofreq to missing value
set qsorst_sent to missing value
set qsorst_rcvd to missing value
set qsomode to missing value
set qsopower to missing value
set qsonote to missing value
set qsogrid to missing value
set qsocall to "[call]"
set qsodate to (current date) - (time to GMT)
try
set year of qsodate to (text 1 thru 4 of "[date_on]")
set month of qsodate to (text 6 thru 7 of "[date_on]")
set day of qsodate to (text 9 thru 10 of "[date_on]")
set hours of qsodate to (text 1 thru 2 of "[time_on]")
set minutes of qsodate to (text 4 thru 5 of "[time_on]")
set seconds of qsodate to (text 7 thru 8 of "[time_on]")
end try
set wsjtxFreq to "[freq]"
set prevTIDs to text item delimiters of AppleScript
set text item delimiters of AppleScript to "."
set wsjtxFreq to text items of wsjtxFreq
set text item delimiters of AppleScript to character 2 of (0.0 as string)
set wsjtxFreq to "" & wsjtxFreq
set text item delimiters of AppleScript to prevTIDs
set qsofreq to wsjtxFreq as real
set qsorst_sent to "[rst_sent]"
set qsorst_rcvd to "[rst_rcvd]"
set qsomode to "[mode]"
set qsopower to "[tx_pwr]"
set qsogrid to "[gridsquare]"
set qsonote to "[comment]"
if qsocall is not missing value then
set loggedQSO to make new qso with properties {callsign:qsocall}
if qsodate is not missing value then set loggedQSO's date to qsodate
if qsofreq is not missing value then set loggedQSO's frequency to qsofreq
if qsorst_sent is not missing value then set loggedQSO's transmitted rst to qsorst_sent
if qsorst_rcvd is not missing value then set loggedQSO's received rst to qsorst_rcvd
if qsomode is not missing value then set loggedQSO's mode to qsomode
if qsopower is not missing value then set loggedQSO's power to qsopower
if qsonote is not missing value then set loggedQSO's note to qsonote
try
lookup loggedQSO
end try
set callBook to loggedQSO's callbook info
if callBook's dxcc code is missing value then
set callBook's dxcc code to DXCC number for qsocall
set callBook's country to DXCC country for qsocall
set callBook's cq zone to CQ zone for qsocall
set callBook's itu zone to ITU zone for qsocall
end if
try
if qsogrid is not missing value then set callBook's grid square to qsogrid
end try
end if
save
end tell
end tell
