tell application "MacLoggerDX"
set radioFreq to frequency
set qsocall to missing value
set qsofreq to missing value
set qsorst_sent to missing value
set qsorst_rcvd to missing value
set qsomode to missing value
set qsogrid to missing value
set qsonote to missing value
set qsopower to missing value
set qsostart to missing value
set qsoend to missing value
set qsocall to "[call]"
set qsorst_sent to "[rst_sent]"
set qsorst_rcvd to "[rst_rcvd]"
set qsomode to "[mode]"
set qsogrid to "[gridsquare]"
set qsopower to "[tx_pwr]"
set qsonote to "[comment]"
if "[qso_date]" is not "" and "[time_on]" is not "" then set qsostart to "[qso_date]" & " " & "[time_on]"
if "[qso_date_off]" is not "" and "[time_off]" is not "" then set qsoend to "[qso_date_off]" & " " & "[time_off]"
lookup qsocall
delay 0.5
set savedMappedMode to mapped_mode
set wsjtxFreq to "[freq]"
set prevTIDs to text item delimiters of AppleScript
set text item delimiters of AppleScript to character 2 of (0.0 as string)
set wsjtxFreq to text items of wsjtxFreq
set text item delimiters of AppleScript to "."
set wsjtxFreq to "" & wsjtxFreq
set text item delimiters of AppleScript to prevTIDs
set offsetFreq to do shell script "echo '" & wsjtxFreq & "'-'" & radioFreq & "' | bc -l"
if not connected then
setLogFrequency offsetFreq
delay 0.5
setLogMode qsomode
else
setVFOLoggingOffset offsetFreq
repeat while mapped_mode is not qsomode
setModeMapping mode & " " & qsomode
delay 0.5
end repeat
end if
if qsorst_sent is not missing value then setRSTS qsorst_sent
if qsorst_rcvd is not missing value then setRSTR qsorst_rcvd
if qsogrid is not missing value then setGRID qsogrid
if qsopower is not missing value then setPOWER qsopower
if qsonote is not missing value then setNOTE qsonote
if qsoend is not missing value then setLogTimeOff qsoend
if qsoend is not missing value then setLogTimeOn qsoend # For WSJT-X 1.7 support
if qsostart is not missing value then setLogTimeOn qsostart
delay 1
log
setModeMapping mode & " " & savedMappedMode
end tell
